.686
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc

include     \masm32\macros\macros.asm

include     \masm32\include\masm32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\msvcrt.inc
; include     \masm32\include\advapi32.inc

includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\msvcrt.lib
; includelib  \masm32\lib\advapi32.lib


.data
p           dd  11, 0, 0, 0
q           dd  19, 0, 0, 0
M           dd   0, 0, 0, 0, 0, 0, 0, 0
s           dd   3, 0, 0, 0
x           dd   0, 0, 0, 0
k           dd   0, 0, 0, 0
kk          dd   0, 0, 0, 0
a           dd   0, 0, 0, 0
i           dd   0, 0, 0, 0

szMessage   db  'Press OK',0,  256 dup (0)
szCaption   db  'Blum Blum Shub Algorithm',0
szFailed    db  'One or both P and Q are unsuitable.',0
szSuceed    db  'Both P and Q are suitable.',0
szCongr     db  'Both P and Q are congruent 3 (mod 4).',0
szCongrNot  db  'Either P or Q are not congruent 3 (mod 4).',0
szPrime     db  'Both P and Q are Prime.',0
szPrimeNot  db  'Either P or Q are not Prime.',0
szFortyOne  db  'Forty One iterations.',0

.code
start:

  invoke MessageBox, 0, ADDR szMessage, ADDR szCaption, MB_OK

;======================================================
; test that both p and q are congruent to 3 (mod 4)
;======================================================

  mov  k, 0

  mov  eax, p
  and  eax, 3
  .if (eax == 3)
     inc k
  .endif

  mov  eax, q
  and  eax, 3
  .if (eax == 3)
     inc k
  .endif

  .if (k == 2)
     invoke MessageBox, 0, ADDR szCongr,    ADDR szCaption, MB_OK
  .else
     invoke MessageBox, 0, ADDR szCongrNot, ADDR szCaption, MB_OK
  .endif

  cmp k, 2
  jne Failed

;======================================================
; test that both p and q are Prime numbers
;======================================================

  mov kk, 0
  
  mov eax, p
  and eax, 1
  .if eax == 1   ; ((p and 1) == 1)
     mov a, 3
     mov ecx, a
     
     mov edx, 0
     mov eax, p
     div ecx
     ; edx == remainder
     .while (ecx < p) && (edx > 0)   ; (a < p) && ((p mod ecx) > 0)
        inc a
        inc a
        mov ecx, a
        mov edx, 0
        mov eax, p
        div ecx
     .endw
     mov eax, a
     .if eax >= p
        inc k
        inc kk
     .endif
  .endif
  .if p == 2
     inc k
     inc kk
  .endif

  mov eax, q
  and eax, 1
  .if eax == 1   ; ((q and 1) == 1)
     mov a, 3
     mov ecx, a
     
     mov edx, 0
     mov eax, q
     div ecx
     ; edx == remainder
     .while (ecx < q) && (edx > 0)   ; (a < q) && ((q mod ecx) > 0)
        inc a
        inc a
        mov ecx, a
        mov edx, 0
        mov eax, q
        div ecx
     .endw
     mov eax, a
     .if eax >= q
        inc k
        inc kk
     .endif
  .endif
  .if q == 2
     inc k
     inc kk
  .endif

 ;   if (p and 1) = 1 then begin
 ;     a := 3;
 ;     while (a < p) and ((p mod a) > 0) do
 ;       a := a + 2;
 ;     if a >= p then
 ;       k := k + 1;
 ;   end;
 ;   if (p = 2) then
 ;     k := k + 1;
 ; 
 ;   if (q and 1) = 1 then begin
 ;     a := 3;
 ;     while (a < q) and ((q mod a) > 0) do
 ;       a := a + 2;
 ;     if a >= q then
 ;       k := k + 1;
 ;   end;
 ;   if (q = 2) then
 ;     k := k + 1;

  .if (kk == 2)
     invoke MessageBox, 0, ADDR szPrime,    ADDR szCaption, MB_OK
  .else
     invoke MessageBox, 0, ADDR szPrimeNot, ADDR szCaption, MB_OK
  .endif

  cmp k, 4
  jne Failed


;======================================================
; if k is 4 both P,Q are prime AND are congruent to 3 (mod 4)
;======================================================

  .if k == 4
     mov eax, p
     mov ecx, q
     mul ecx
     mov M + 0, eax
     mov M + 4, edx

     mov eax, s
     mov x, eax

     mov eax, 0
     mov i, eax
     .repeat
        mov eax, x
        mul eax
        mov x + 0, eax
        mov x + 4, edx
        .if (edx > M + 4) || ((edx == M + 4) && (eax >= M + 0))
          .repeat
             mov eax, x
             sub eax, M
             mov x, eax
             mov edx, x + 4
             sbb edx, M + 4
             mov x + 4, edx
          .until (edx < M + 4) || ((edx == M + 4) && (eax < M))
        .endif
        inc i
     .until i > 40
     .if i > 40
        invoke MessageBox, 0, ADDR szFortyOne,   ADDR szCaption, MB_OK
     .endif
  .endif

  jmp Suceed

 ;   if k = 4 then begin
 ;     M := p*q;
 ;     x := s;
 ; 
 ;     i := 0;
 ;     repeat
 ;     x := x*x;
 ;     if x >= M then
 ;       repeat
 ;         x := x - M;
 ;       until x < M;
 ;     writeln(x);
 ;     i := i + 1;
 ;     until i > 40;
 ;   end;

Failed: 
  invoke MessageBox, 0, ADDR szFailed,   ADDR szCaption, MB_OK
  jmp Past

Suceed: 
  invoke MessageBox, 0, ADDR szSuceed,   ADDR szCaption, MB_OK

Past:
  invoke ExitProcess, 0

end start